# Send custom metrics POST https://app.unleash-instance.example.com/api/client/metrics/custom Content-Type: application/json This operation accepts custom metrics from clients. These metrics will be exposed via Prometheus in Unleash. Reference: https://docs.getunleash.io/api/client-custom-metrics ## OpenAPI Specification ```yaml openapi: 3.1.1 info: title: Send custom metrics version: endpoint_client.customMetrics paths: /api/client/metrics/custom: post: operationId: custom-metrics summary: Send custom metrics description: >- This operation accepts custom metrics from clients. These metrics will be exposed via Prometheus in Unleash. tags: - - subpackage_client parameters: - name: Authorization in: header description: Header authentication of the form `undefined ` required: true schema: type: string responses: '202': description: This response has no body. content: application/json: schema: $ref: '#/components/schemas/Client_customMetrics_Response_202' '400': description: The request data does not match what we expect. content: {} requestBody: description: customMetricsSchema content: application/json: schema: $ref: '#/components/schemas/customMetricsSchema' components: schemas: customMetricSchema: type: object properties: name: type: string description: Name of the custom metric value: type: number format: double description: Value of the custom metric labels: type: object additionalProperties: type: string description: Labels to categorize the metric required: - name - value customMetricsSchema: type: object properties: metrics: type: array items: $ref: '#/components/schemas/customMetricSchema' description: Array of custom metrics required: - metrics Client_customMetrics_Response_202: type: object properties: {} ``` ## SDK Code Examples ```python import requests url = "https://app.unleash-instance.example.com/api/client/metrics/custom" payload = { "metrics": [ { "name": "http_responses_total", "value": 1 } ] } headers = { "Authorization": "", "Content-Type": "application/json" } response = requests.post(url, json=payload, headers=headers) print(response.json()) ``` ```javascript const url = 'https://app.unleash-instance.example.com/api/client/metrics/custom'; const options = { method: 'POST', headers: {Authorization: '', 'Content-Type': 'application/json'}, body: '{"metrics":[{"name":"http_responses_total","value":1}]}' }; try { const response = await fetch(url, options); const data = await response.json(); console.log(data); } catch (error) { console.error(error); } ``` ```go package main import ( "fmt" "strings" "net/http" "io" ) func main() { url := "https://app.unleash-instance.example.com/api/client/metrics/custom" payload := strings.NewReader("{\n \"metrics\": [\n {\n \"name\": \"http_responses_total\",\n \"value\": 1\n }\n ]\n}") req, _ := http.NewRequest("POST", url, payload) req.Header.Add("Authorization", "") req.Header.Add("Content-Type", "application/json") res, _ := http.DefaultClient.Do(req) defer res.Body.Close() body, _ := io.ReadAll(res.Body) fmt.Println(res) fmt.Println(string(body)) } ``` ```ruby require 'uri' require 'net/http' url = URI("https://app.unleash-instance.example.com/api/client/metrics/custom") http = Net::HTTP.new(url.host, url.port) http.use_ssl = true request = Net::HTTP::Post.new(url) request["Authorization"] = '' request["Content-Type"] = 'application/json' request.body = "{\n \"metrics\": [\n {\n \"name\": \"http_responses_total\",\n \"value\": 1\n }\n ]\n}" response = http.request(request) puts response.read_body ``` ```java import com.mashape.unirest.http.HttpResponse; import com.mashape.unirest.http.Unirest; HttpResponse response = Unirest.post("https://app.unleash-instance.example.com/api/client/metrics/custom") .header("Authorization", "") .header("Content-Type", "application/json") .body("{\n \"metrics\": [\n {\n \"name\": \"http_responses_total\",\n \"value\": 1\n }\n ]\n}") .asString(); ``` ```php request('POST', 'https://app.unleash-instance.example.com/api/client/metrics/custom', [ 'body' => '{ "metrics": [ { "name": "http_responses_total", "value": 1 } ] }', 'headers' => [ 'Authorization' => '', 'Content-Type' => 'application/json', ], ]); echo $response->getBody(); ``` ```csharp using RestSharp; var client = new RestClient("https://app.unleash-instance.example.com/api/client/metrics/custom"); var request = new RestRequest(Method.POST); request.AddHeader("Authorization", ""); request.AddHeader("Content-Type", "application/json"); request.AddParameter("application/json", "{\n \"metrics\": [\n {\n \"name\": \"http_responses_total\",\n \"value\": 1\n }\n ]\n}", ParameterType.RequestBody); IRestResponse response = client.Execute(request); ``` ```swift import Foundation let headers = [ "Authorization": "", "Content-Type": "application/json" ] let parameters = ["metrics": [ [ "name": "http_responses_total", "value": 1 ] ]] as [String : Any] let postData = JSONSerialization.data(withJSONObject: parameters, options: []) let request = NSMutableURLRequest(url: NSURL(string: "https://app.unleash-instance.example.com/api/client/metrics/custom")! as URL, cachePolicy: .useProtocolCachePolicy, timeoutInterval: 10.0) request.httpMethod = "POST" request.allHTTPHeaderFields = headers request.httpBody = postData as Data let session = URLSession.shared let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in if (error != nil) { print(error as Any) } else { let httpResponse = response as? HTTPURLResponse print(httpResponse) } }) dataTask.resume() ```